import net from 'net';
import { Client } from '.';

export default class Context {
  public socket: net.Socket;

  public client: Client;

  public data: {
    username: string,
    endpoint: string,
    message?: string,
    additionalData?: object,
    HMAC: string,
  }

  constructor(socket: net.Socket, data: string, client: Client) {
    const parsed: { Username: string, Type: string, Message?: string, Data?: object, HMAC: string } = JSON.parse(data);

    this.socket = socket;
    this.client = client;
    this.data = {
      username: parsed.Username,
      endpoint: parsed.Type,
      message: parsed.Message,
      additionalData: parsed.Data,
      HMAC: parsed.HMAC,
    };
  }

  public send(v: string) {
    this.socket.write(`${v.toString()}\n`, (err) => {
      if (err) {
        this.client.signale.error(`Error occurred while writing: ${err}`);
      }
    });
    this.socket.destroy();
  }
}
