import { Message } from 'discord.js';
import { Client, Command } from '../class';

export default class Ping extends Command {
  constructor(client: Client) {
    super(client);
    this.name = 'ping';
    this.description = 'Pings the bot';
    this.enabled = true;
  }

  public async run(message: Message) {
    try {
      const clientStart: number = Date.now();
      const msg: Message = await message.channel.send('🏓 Pong!');
      msg.edit(`🏓 Pong!\nClient: \`${Date.now() - clientStart}ms\`\nResponse: \`${msg.createdTimestamp - message.createdTimestamp}ms\``);
    } catch (error) {
      this.client.util.handleError(error, message, this);
    }
  }
}
