import { Message } from 'discord.js';
import { Client, Command } from '../class';
import SystemD_Linger from './systemd_linger';
import SystemD_Status from './systemd_status';
import SystemD_Start from './systemd_start';
import SystemD_Restart from './systemd_restart';
import SystemD_Stop from './systemd_stop';

export default class SystemD extends Command {
  constructor(client: Client) {
    super(client);
    this.name = 'systemd';
    this.description = 'Manages various aspects for your user SystemD.';
    this.usage = `Run ${this.client.config.prefix}${this.name} [subcommand] for usage information`;
    this.subcmds = [SystemD_Linger, SystemD_Status, SystemD_Start, SystemD_Restart, SystemD_Stop];
    this.enabled = true;
  }

  public run(message: Message) {
    try {
      return this.client.commands.get('help').run(message, [this.name]);
    } catch (error) {
      return this.client.util.handleError(error, message, this);
    }
  }
}
