import { Client, CSCLI } from './class';
import * as eventFiles from './events';
import * as commandFiles from './commands';
import * as handlerFiles from './cscli';

// eslint-disable-next-line no-new
async function main() {
  const client = new Client();
  await client.loadCommands(commandFiles);
  await client.loadEvents(eventFiles);
  await client.loadFunctions();
  await client.init();
  const cscli = new CSCLI(client);
  cscli.load(handlerFiles);
}

main();
