import { Document, Schema, model } from 'mongoose';

export interface Tiers {
  id: number,
  resourceLimits: {
    // In MB
    ram: number, storage: number
  }
}

export interface TierInterface extends Tiers, Document {
  id: number;
}

const Tier = new Schema<TierInterface>({
  id: Number,
  resourceLimits: {
    ram: Number,
    storage: Number,
  },
}, { id: false });

export default model<TierInterface>('Tier', Tier);
